<template lang="pug">
.explore
  .container
    .row.my-4
      .col-12.col-md-8
        b-form
          b-form-group#input-group-1(
            label=''
            label-for='suggestion'
            )
            b-input-group
              gmap-autocomplete#suggestion.form-control(
                ref="suggestion"
                :value="findPlace.formatted_address"
                @place_changed="placeChanged"
                placeholder="ค้นหาสถานที่ใน Google Map")
              b-button(
                size="sm"
                :to="{ name: 'explore' }"
              ) Search
      .col-12.col-md-4
        .text-right
          b-form
            b-form-group#input-group-2(
              label=''
              label-for='input-2'
              )
              b-button.w-100(
                size="md"
                @click="getLocation"
                ) Nearby Me
    .row
      .col-12
        no-ssr
          div.google-map.w-100#map
    .row
      .col-12
        .container.my-5
          place-items(:lists="parseList")
</template>

<script>
import settings from '~/settings'
import _ from 'lodash'
import PlaceItems from '~/components/pages/explore/place'

export default {
  components: {
    PlaceItems
  },
  data() {
    return {
      findPlace: {},
      currentLocation: {
        lat: 13.00,
        lng: 100.00
      },
      googleMap: {},
      service: {},
      markers: [],
      infoWindows: [],
      placeNearby: [],
      lists: []
    }
  },
  watch: {
    currentLocation: {
      deep: true,
      handler: function(to) {
        this.fetchPlace()
        
      }
    }
  },
  computed: {
    parseList() {
      return _.values(_.mapValues(this.placeNearby, o => {
          return {
            ...o,
            id: o.shop.place_id,
            name: o.shop.name,
            to: o.detail.website,
            rating: o.detail.rating || false,
            thumb_image: {
              title: o.shop.name,
              description: o.shop.name,
              url: o.detail.photos ? o.detail.photos[0].getUrl() : 'https://via.placeholder.com/360x208'
            },
            is_pin: 0
          }
        })
      )
    }
  },
  mounted() {
    if(localStorage.getItem('findPlace')) {
      const findPlace = JSON.parse(localStorage.getItem('findPlace'))
      this.findPlace = findPlace
      this.currentLocation.lat = findPlace.location.lat,
      this.currentLocation.lng = findPlace.location.lng
    }
    
    this.initGmap()
  },
  methods: {
    initGmap() {
     this.$gmapApiPromiseLazy().then(() => {
        this.googleMap = new google.maps.Map(document.getElementById('map'), {
          center: { lat: this.currentLocation.lat, lng: this.currentLocation.lng },
          zoom: 15,
          // disableDefaultUI: true
        })

     })
    },
    async fetchPlace() {
      var param = JSON.parse(localStorage.getItem('findPlace'))
      this.markers = []
      this.infoWindows = []
      this.placeNearby = []
      // this.$axios.get(
      //   `https://maps.googleapis.com/maps/api/place/findplacefromtext/json?input=${param.formatted_address}&inputtype=textquery&locationbias=circle:2000@${this.currentLocation.lat},${this.currentLocation.lng}&key=${settings.google.key}`
      // )
      // .then(res => {
      //   console.log(res.data)
      //   return Promise.resolve(res.data)
      // })
      
      this.$gmapApiPromiseLazy().then(() => {
        this.googleMap.panTo(this.currentLocation)
        this.addCurrentPin(this.googleMap)
        this.service  = new google.maps.places.PlacesService(this.googleMap);
        var request = {
            location: this.currentLocation,
            radius: '800',
            type: ['restaurant'],
          };
        this.service.nearbySearch(request, (results, status) => {
          if (status === google.maps.places.PlacesServiceStatus.OK) {
            this.addMarker(this.googleMap, results)
          }
        });

      })
      // service.findPlaceFromQuery(request, function(results, status) {
      //   if (status === google.maps.places.PlacesServiceStatus.OK) {
      //     console.log(results)
      //   }
      // });
      // console.log(https://maps.googleapis.com/maps/api/place/findplacefromtext/json?input=mongolian%20grill&inputtype=textquery&fields=photos,formatted_address,name,opening_hours,rating&locationbias=circle:2000@47.6918452,-122.2226413&key=YOUR_API_KEY)
    },
    addCurrentPin(map) {
      let marker = new google.maps.Marker({
        position: { lat: this.currentLocation.lat, lng: this.currentLocation.lng },
        map: map,
        icon: {
          url: '/images/logo/current-pin.png',
          scaledSize: new google.maps.Size(48, 48) // scaled size
        },
        detail: 'Current Pin',
        animation: google.maps.Animation.DROP
      })
      this.markers.push(marker)
    },

    addMarker(map, list) {
      let count = 0
      _.each(list, shop => {
        var place
        var request = {
          placeId: shop.place_id,
          fields: ['name', 'formatted_address','photos', 'rating', 'place_id', 'geometry','website']
        };
        this.service.getDetails(request, (place, status) => {
          if (status === google.maps.places.PlacesServiceStatus.OK) {
            this.placeNearby.push({
              shop: shop,
              detail: place
            })
            let marker = new google.maps.Marker({
              position: { lat: place.geometry.location.lat(), lng: place.geometry.location.lng() },
              map: map,
              icon: {
                url: '/images/logo/logo-pin.png',
                scaledSize: new google.maps.Size(24, 24) // scaled size
              },
              detail: place.name,
              markerIndex: count,
              animation: google.maps.Animation.DROP
            })

            let lat = place.geometry.location.lat()
            let lng = place.geometry.location.lng()
            let name = place.name
            let url = place.website || ''
            let infoWindowPos = { lat: lat, lng: lng }
            let infoContent
            if(place.website) {
              infoContent = '<div class="p-2"><a target="_blank" href="'+ place.website +'"><span style="color:#175B9D;"><strong>' +
              name +
              '</strong></span></a><br /><span style="color:#1FBBB4;">' +
              place.formatted_address +
              '</span></a></div>'
            } else {
              infoContent = '<div class="p-2"><span style="color:#175B9D;"><strong>' +
              name +
              '</strong></span><br /><span style="color:#1FBBB4;">' +
              place.formatted_address +
              '</span></a></div>'
            }

            let infoWindow = new google.maps.InfoWindow({
              content: infoContent,
              position: infoWindowPos
            })
            this.infoWindows.push(infoWindow)
            marker.addListener('click', e => {
              this.infoWindows[marker.markerIndex].open(this.googleMap, marker)
            })

            count++
            this.markers.push(marker)
          }
        })

      })
    },

    placeChanged(e){
      localStorage.setItem('findPlace', JSON.stringify({
          name: e.name,
          formatted_address: e.formatted_address,
          location: {
            lat: e.geometry.location.lat(),
            lng: e.geometry.location.lng()
          }
        })
      )
      this.currentLocation.lat = e.geometry.location.lat(),
      this.currentLocation.lng = e.geometry.location.lng()
    },
    
    getLocation () {
      return new Promise((resolve) => {
        if (navigator) {
          if (navigator.geolocation) {
            navigator.geolocation.getCurrentPosition(
              position => {
                this.currentLocation.lat = position.coords.latitude
                this.currentLocation.lng = position.coords.longitude
              },
              error => {
                this.errorGeo = error
              },
              { timeout: 30000, enableHighAccuracy: true, maximumAge: 75000 }
            )
          } else {
            this.errorGeo = 'Error: no geolocation'
          }
        }
        resolve()
      })
    }
  }
}
</script>

<style lang="scss" scoped>
.explore {
  min-height: 100vh;
}
.google-map {
  min-height: 400px;
}
</style>